VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmIESReader 
   Caption         =   "IES Reader"
   ClientHeight    =   4575
   ClientLeft      =   780
   ClientTop       =   435
   ClientWidth     =   5055
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   5055
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdReadIES 
      Caption         =   "Read IES"
      Height          =   495
      Left            =   1680
      TabIndex        =   2
      Top             =   1560
      Width           =   1695
   End
   Begin VB.TextBox txtPath 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   4815
   End
   Begin VB.CommandButton cmdSetPath 
      Caption         =   "Set File Path"
      Height          =   495
      Left            =   960
      TabIndex        =   0
      Top             =   120
      Width           =   3135
   End
   Begin MSComDlg.CommonDialog IESDialog 
      Left            =   4320
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "frmIESReader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Dim IDSpace(1 To 65)
Dim TmpColumnHeader(1 To 100)
Dim Floats(1 To 250)
Dim CharacterArray(1 To 500)
Dim Strings(1 To 250)
Dim ColumnHeader(1 To 500) As String
Dim TmpString As String
Private Sub cmdReadIES_Click()
Dim DataFile As String
Dim PosString, WhereString
Dim DataFileNum, TmpReturn$
Dim TmpString
Dim TmpLOF
Dim IsAltered As Boolean
Dim IDSpaceObtained As Boolean
Dim StringBool As Boolean
Dim NumberBool As Boolean
Dim NewString$, strIDSpace

DataFile = txtPath.Text
DataFileNum = FreeFile
    
FileCheck = FileExists(DataFile)
    
If FileCheck = False Then
    MsgBox "No Such File"
    Exit Sub
End If

Erase IDSpace, ColumnHeader, TmpColumnHeader

PosString = 1
Index = 1

Open DataFile For Binary As DataFileNum

Do
    TmpReturn$ = Space$(1)
    Get #DataFileNum, PosString, TmpReturn$
    If TmpReturn$ <> Chr(0) And PosString < 64 Then
        IDSpace(Index) = TmpReturn$
        Index = Index + 1
    Else
        IDSpaceObtained = True
    End If
    
    If IDSpaceObtained = True Then
    '77 = FileSize - 4 Byte
    PosString = 77
    TmpReturn$ = Space$(4)
    Get #DataFileNum, PosString, TmpReturn$
    TmpReturn$ = StrReverse(TmpReturn$)
    TmpCheck = string2hex(TmpReturn$)
    FileSize = CLng("&H" & TmpCheck)

    
    '83 = Rows
    TmpReturn$ = Space$(2) 'Changing the Size of the return
    PosString = 83
    Get #DataFileNum, PosString, TmpReturn$
    TmpReturn$ = StrReverse(TmpReturn$)
    TmpCheck = string2hex(TmpReturn$)
    AmountOfRows = CLng("&H" & TmpCheck)
    
    '85 = Columns
    PosString = 85
    Get #DataFileNum, PosString, TmpReturn$
    TmpReturn$ = StrReverse(TmpReturn$)
    TmpCheck = string2hex(TmpReturn$)
    AmountOfColumns = CLng("&H" & TmpCheck)

    '87 = How many columns are Numeric
    PosString = 87
    Get #DataFileNum, PosString, TmpReturn$
    TmpReturn$ = StrReverse(TmpReturn$)
    TmpCheck = string2hex(TmpReturn$)
    TotalNumber = CLng("&H" & TmpCheck)
    
    PosString = 89
    Get #DataFileNum, PosString, TmpReturn$
    TmpReturn$ = StrReverse(TmpReturn$)
    TmpCheck = string2hex(TmpReturn$)
    TotalString = CLng("&H" & TmpCheck)
    
    For i = 1 To 65
    TmpFinal = IDSpace(i)
        If TmpFinal = "" Then
            Exit For
        End If
    strIDSpace = strIDSpace + TmpFinal
    Next
    
    Exit Do
    End If
    
PosString = PosString + 1
Loop Until PosString = (LOF(DataFileNum) + 1)

Index = 1
TmpPosString = 93
PosString = TmpPosString
TotalAmount = 0
HeaderIndex = 1
TmpReturn$ = Space$(1)

Do
Get #DataFileNum, PosString, TmpReturn$
   If TmpReturn$ <> Chr(0) Then
        TmpColumnHeader(Index) = TmpReturn$
        Index = Index + 1
        PosString = PosString + 1
    ElseIf TmpReturn$ = Chr(0) Then
        TmpPosString = TmpPosString + 134
        TotalAmount = TotalAmount + 1
            For i = 1 To 30
                TmpFinal = TmpColumnHeader(i)
                TmpString = TmpFinal
                TmpString = Decode(TmpString)
                Final = Final + TmpString
            Next
            
            'Decide if String or Number
            TmpReturn$ = Space$(68)
            Get #DataFileNum, (TmpPosString + 64 - 134), TmpReturn$
                If InStr(1, TmpReturn$, Chr(1)) Then
                    DataTypeStore = " (String)"
                Else
                    DataTypeStore = " (Number)"
                End If
            Final = Final + DataTypeStore
            'MsgBox Final
            TmpReturn$ = Space$(1)
                
            Erase TmpColumnHeader

            ColumnHeader(HeaderIndex) = Final
            HeaderIndex = HeaderIndex + 1
            
            TmpFinal = ""
            Final = ""
            PosString = TmpPosString
            Index = 1
    End If
Loop Until PosString = (LOF(DataFileNum) + 1) Or TotalAmount = AmountOfColumns

'Start getting data
'This is where data starts, -2 Bytes = XX
'If XX <> 00 00 Then its a String
'XX Represent the Length of the String
'At The end of a "row" there 2 bytes (Nulls) then there is
'7 bytes until the next piece of data.
'first 2 bytes of the 7 bytes is row number
'Row number begins at 00, 2nd row is 01 etc
'Reversed it would be this
'0, 256, 516, 1024 etc
'All Floats are grouped!
'If its a String first then Float(Numeric) after
'It makes up the space by adding Nulls?

TmpPosString = (TmpPosString + 140) - 134
CurrentNumber = 0
CurrentString = 0
TotalOverall = 0
HasLooped = False

'Start Loop Here?
Do
    If HasLooped = True Then
        'Update TmpPosString
        TmpPosString = PosString + 9 'Should be 7 however with the -2 later in the code
                                     'I changed it to + 9
        HasLooped = False
    End If
    
    Do
        If HasLooped = False Then
            PosString = TmpPosString - 2
        End If
        
    TmpReturn$ = Space$(1)
    Get #DataFileNum, PosString, TmpReturn$
        'If TmpReturn$ = Chr(0) Then
        '    TmpReturn$ = 0
        'Else
            TmpReturn$ = string2hex(TmpReturn$)
            TmpReturn$ = CLng("&H" & TmpReturn$)
        'End If
        
        If PosString > 24100 Then
        MsgBox TmpReturn$ & "     " & PosString
        End If
    
        If TmpReturn$ <> 0 Then
            TmpLength = TmpReturn$
            PosString = PosString + 1
            TmpReturn$ = Space$(1)
            Get #DataFileNum, PosString, TmpReturn$
                If TmpReturn$ = Chr(0) Then
                    TmpReturn$ = Space$(TmpLength) 'String
                    StringBool = True
                Else
                    TmpReturn$ = Space$(4) 'Float
                    NumberBool = True
                End If
            PosString = PosString - 1
        Else
            TmpReturn$ = Space$(4) 'Float
            NumberBool = True
        End If
        
        If CurrentNumber = TotalNumber Then
            NumberBool = False
        End If
        
        'If HasLooped = False Then
        '    PosString = PosString + 2
        'End If
        
        If CurrentString > 0 And CurrentNumber <> TotalNumber Then
            'PosString = PosString + 2
            Do
                Get #DataFileNum, PosString, TmpReturn$
                TmpReturn$ = StrReverse(TmpReturn$)
                TmpReturn$ = string2hex(TmpReturn$)
                Floats(CurrentNumber + 1) = Hex2Float(TmpReturn$)
                TmpReturn$ = Space$(4)
                PosString = PosString + 4
                CurrentNumber = CurrentNumber + 1
            Loop Until CurrentNumber = TotalNumber
            NumberBool = False
        ElseIf NumberBool = True And CurrentNumber <> TotalNumber Then
            PosString = PosString + 2
            Do
                Get #DataFileNum, PosString, TmpReturn$
                TmpReturn$ = StrReverse(TmpReturn$)
                TmpReturn$ = string2hex(TmpReturn$)
                Floats(CurrentNumber + 1) = Hex2Float(TmpReturn$)
                TmpReturn$ = Space$(4)
                PosString = PosString + 4
                CurrentNumber = CurrentNumber + 1
            Loop Until CurrentNumber = TotalNumber
            NumberBool = False
        ElseIf StringBool = True And CurrentString <> TotalString Then
            PosString = PosString + 2
            Get #DataFileNum, PosString, TmpReturn$
            LenString = Len(TmpReturn$)
            x = 0
                For i = 1 To LenString
                    x = x + 1
                    TmpString = TmpReturn$
                    TmpString = Mid$(TmpString, x, 1)
                    TmpString = Decode(TmpString)
                    CharacterArray(i) = TmpString
                Next
            TmpReturn$ = Join(CharacterArray)
            Erase CharacterArray
            TmpReturn$ = Replace(TmpReturn$, "  ", Chr(0)) 'When You Join it adds a space
            TmpReturn$ = Replace(TmpReturn$, " ", "")      'Inbetween each "part" of the array
            TmpReturn$ = Replace(TmpReturn$, Chr(0), " ")  'So keep Spaces are meant to be there
                                                           'These Replaces have to be here
            Strings(CurrentString + 1) = TmpReturn$
            'If PosString > 24100 Then
            MsgBox TmpReturn$
            'End If
            PosString = PosString + TmpLength
            CurrentString = CurrentString + 1
            StringBool = False
        Else
            PosString = PosString + 1
        End If
        HasLooped = True
        
        'Note Updated code, works well for Item_Consume until 3rd row
        'Checking for blanks
        'Experimental Code
        'Needs Rework ~ Basicly
        'When it comes to the end with Nulls
        'there are X amount divide that by 3 and add
        'it to current string then you get the total
        'Which means its ended the read so it needs
        'to continue onto the next part where it will
        'skip 7 bytes to read the next piece of data
        'this code is really needed!
        
        'Also code for checking to see if an extra
        'string is in is needed as well because that
        'can cause some problems.
        
        'We Can detect if there is an extra string
        'by checking the next 2 bytes if its not
        '0 then it means there is a string there
        'we can just skip it by getting the length
        'and skipping it using that method.
        '''''''''''''''''''''''''''''''''''''''''''
        TmpCalc = (TotalString - (CurrentString - 1)) * 3
        If TmpCalc > 0 Then
            TmpReturn$ = Space$(TmpCalc)
        End If
        Get #DataFileNum, PosString, TmpReturn$
        TmpStringReplace = Replace(TmpReturn$, Chr(0), "")
        TmpStringReplace = Replace(TmpStringReplace, Chr(1), "")
        If TmpStringReplace = "" And FileSize > 10000 Then  'And CurrentString < TotalString Then
            CurrentString = CurrentString + (TmpCalc / 3)
            'Update PosString
            PosString = (PosString + TmpCalc) - 2
        End If
        ''''''''''''''''''''''''''''''''''''''''''''

    Loop Until CurrentString >= TotalString And CurrentNumber = TotalNumber

TotalOverall = TotalOverall + 1
CurrentString = 0
CurrentNumber = 0

Loop Until TotalOverall = AmountOfRows
Close
End Sub
Private Sub cmdSetPath_Click()
IESDialog.DialogTitle = "Select name and location of the IES file"
IESDialog.DefaultExt = "IES"
IESDialog.Filter = "IES | *.IES"
IESDialog.ShowOpen
If IESDialog.FileName <> "" Then
    strName = IESDialog.FileName
    txtPath.Text = strName
End If
End Sub
Public Function Hex2Float(ByVal tmpHex As String) As Single
Dim TmpSng As Single
Dim tmpLng As Long
tmpLng = CLng("&H" & tmpHex)
Call CopyMemory(ByVal VarPtr(TmpSng), ByVal VarPtr(tmpLng), 4)
Hex2Float = TmpSng
End Function
